pub mod connection_info;
pub mod event;
pub mod payload;
pub mod presence;

mod close_code;
mod frame;
mod id;
mod intents;
mod opcode;
mod reaction;
mod session_start_limit;

pub use self::{
    close_code::{CloseCode, CloseCodeConversionError},
    frame::CloseFrame,
    id::{ShardId, ShardIdParseError, ShardIdParseErrorType},
    intents::Intents,
    opcode::OpCode,
    reaction::GatewayReaction,
    session_start_limit::SessionStartLimit,
};
